using System;
using Microsoft.AspNetCore.Hosting;
using Microsoft.Extensions.Hosting;
using Microsoft.Extensions.DependencyInjection;

namespace DIAndTheProgramCsCore31
{
    public class Program
    {
        public static void Main(string[] args)
        {
            IHost host = CreateHostBuilder(args).Build();

            DoSomethingWithTheTransientService(host.Services);
            DoSomethingWithTheSingletonService(host.Services);
            host.Run();
        }

        public static IHostBuilder CreateHostBuilder(string[] args) =>
            Host.CreateDefaultBuilder(args)
            .ConfigureWebHostDefaults(webBuilder =>
            {
                webBuilder.UseStartup<Startup>();
            });

        private static void DoSomethingWithTheTransientService(IServiceProvider serviceProvider)
        {
            Console.WriteLine("Calling the transient service");

            var serviceOne = serviceProvider.GetService<IServiceOne>();
            Console.WriteLine(serviceOne.StaticCounter());
            Console.WriteLine(serviceOne.GetHashCode());
        }

        private static void DoSomethingWithTheSingletonService(IServiceProvider serviceProvider)
        {
            Console.WriteLine("Calling the singleton service");

            var serviceTwo = serviceProvider.GetService<IServiceTwo>();
            Console.WriteLine(serviceTwo.StaticCounter());
            Console.WriteLine(serviceTwo.GetHashCode());
        }
    }
}
